unit EanPdf417;

interface

uses Classes, Windows, Graphics, Dialogs, SysUtils;

resourcestring
        rsBadCharInPDF417='Bad char in PDF417, position %d, char : %s';
type
        psPDF417Mode = (psPDF417Alphanumeric, psPDF417Binary, psPDF417BinaryHex, psPDF417Numeric, psPDF417AutoCode);
        psPDF417ErrorCorrection = (psPDF417AutoEC,psPDF417Error0, psPDF417Error1, psPDF417Error2,
                                   psPDF417Error3, psPDF417Error4, psPDF417Error5,
                                   psPDF417Error6, psPDF417Error7, psPDF417Error8 );



        TInteger5 = array[0..4] of Integer;
        TByte6    = array[0..5] of Byte;

        TIntegerArray = record
             Count : Integer;
             CodeWords: Array [0..2000] of Integer;
        end;


        procedure PaintPDF417(C:TCanvas; R:TRect);

        function Pdf417CodewordToBars(cw:Integer; row:Integer):String;
        function Pdf417OneRowToBars(Row,RowCount,SecurityLevel:Integer; CodeWords:TIntegerArray):String;

        function Base256ToBase900(B6:TByte6):TInteger5;

        procedure PdfBinaryToCodeWords(s:String; var R:TIntegerArray);
        procedure PdfBinaryHexToCodeWords(s:String; var R:TIntegerArray);
        procedure PdfTextToCodeWords(s:String; var R:TIntegerArray);
        procedure PdfNumericToCodeWords(s:String; var R:TIntegerArray);
        function PdfCalcErrorCodes(D:TIntegerArray; ErrorLevel:Integer; ErrCount:Integer):TIntegerArray;



        function Pdf417LeftRowIndicator(RowNumber,NumberOfRows,SecurityLevel,ColumnCount:Integer):Integer;
        function Pdf417RightRowIndicator(RowNumber,NumberOfRows,SecurityLevel,ColumnCount:Integer):Integer;

        procedure GetCompletePDF417LinesBars(S:String; var Cols, Rows:Integer; SecLevel:psPDF417ErrorCorrection;
                  CodingScheme:psPDF417Mode; Truncated:Boolean; L:TStringList);
        function PDF417MinWidth(S:String; Cols, Rows:Integer; SecLevel:psPDF417ErrorCorrection;
                  CodingScheme:psPDF417Mode; Truncated:Boolean):Integer;

implementation

